import sys
from sudoku import SudokuBoard
from runner import SolverRunner

class MySudokuSolver:
    
    def solve(self, board):
        """Return the solved board."""
        
        # PUT YOUR SOLUTION STRATEGY HERE.
        # THIS IMPLEMENTATION DOES NOTHING - IT JUST RETURNS THE BOARD GIVEN AS THE ARGUMENT
        solved_board = board
        return solved_board
    
    
def simple_test():
    board = SudokuBoard()
    board.from_full_state([
        [1,0,0,0],
        [0,2,0,0],
        [0,0,3,0],
        [0,0,0,4]])    
    solver = MySudokuSolver()
    solved_board = solver.solve(board)
    print(solved_board)
    
usage_message = """
Executes the sudoku solver in a batch mode.

Usage:
   > python3 solver.py path/to/tasks path/to/solutions
   
path/to/tasks
   Path to directory containing the sudoku tasks in the form of .ss files.
   
path/to/solutions
   Path to directory where the solved sudokus shall be saved in the form of .ss files.
"""
    
if __name__ == '__main__':
    if len(sys.argv) == 2:
        # Run a simple test if 'test' given as script argument
        if sys.argv[1] == 'test':
            simple_test()
            sys.exit(0)
            
    if len(sys.argv) == 3:
        # Assume the batch mode
        tasks_dir, sols_dir = sys.argv[1:3]
        runner = SolverRunner(MySudokuSolver, tasks_dir, sols_dir)
        runner.run()
        sys.exit(0)
    
    print(usage_message)
    sys.exit(1)
